/// @cond EO_CXX_EO_IMPL

inline ::elm_view_list::_c_genlist_set elm_view_list::genlist_set(Evas_Object * genlist_, Elm_Genlist_Item_Type item_type_, ::efl::eina::string_view item_style_)
{
   return _c_genlist_set(genlist_, item_type_, item_style_);
}

inline void elm_view_list::evas_object_get(Evas_Object ** widget_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_evas_object_get(widget_));
}

inline void elm_view_list::property_connect(::efl::eina::string_view property_, ::efl::eina::string_view part_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_property_connect(::efl::eolian::to_c(property_), ::efl::eolian::to_c(part_)));
}

inline void elm_view_list::model_set(::efl::model::base model_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_set(::efl::eolian::to_c(model_)));
}

inline void elm_view_list::model_unset() const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_unset());
}

inline void elm_view_list::model_get(::efl::eo::concrete* model_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_get(::efl::eolian::to_c(model_)));
}

inline void eo_cxx::elm_view_list::evas_object_get(Evas_Object ** widget_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_evas_object_get(widget_));
}

inline void eo_cxx::elm_view_list::property_connect(::efl::eina::string_view property_, ::efl::eina::string_view part_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_property_connect(::efl::eolian::to_c(property_), ::efl::eolian::to_c(part_)));
}

inline void eo_cxx::elm_view_list::model_set(::efl::model::base model_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_set(::efl::eolian::to_c(model_)));
}

inline void eo_cxx::elm_view_list::model_unset() const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_unset());
}

inline void eo_cxx::elm_view_list::model_get(::efl::eo::concrete* model_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_view_list_model_get(::efl::eolian::to_c(model_)));
}

inline ::eo_cxx::elm_view_list::operator ::elm_view_list() const
{
   return *static_cast<::elm_view_list const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_view_list::operator ::elm_view_list&()
{
   return *static_cast<::elm_view_list*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_view_list::operator ::elm_view_list const&() const
{
   return *static_cast<::elm_view_list const*>(static_cast<void const*>(this));
}

template <typename T>
void _elm_view_list_evas_object_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object ** widget_)
{
   try
      {
         static_cast<T*>(self->this_)->evas_object_get(widget_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_view_list_property_connect_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * property_, const char * part_)
{
   try
      {
         static_cast<T*>(self->this_)->property_connect(::efl::eolian::to_cxx<::efl::eina::string_view>(property_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(part_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_view_list_model_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Efl_Model_Base * model_)
{
   try
      {
         static_cast<T*>(self->this_)->model_set(::efl::eolian::to_cxx<::efl::model::base>(model_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_view_list_model_unset_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->model_unset();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_view_list_model_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eo ** model_)
{
   try
      {
         static_cast<T*>(self->this_)->model_get(::efl::eolian::to_cxx<::efl::eo::concrete*>(model_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_view_list >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual void evas_object_get(Evas_Object ** widget_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_list_evas_object_get(widget_));
      }

      virtual void property_connect(::efl::eina::string_view property_, ::efl::eina::string_view part_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_list_property_connect(::efl::eolian::to_c(property_), ::efl::eolian::to_c(part_)));
      }

      virtual void model_set(::efl::model::base model_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_list_model_set(::efl::eolian::to_c(model_)));
      }

      virtual void model_unset()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_list_model_unset());
      }

      virtual void model_get(::efl::eo::concrete* model_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_view_list_model_get(::efl::eolian::to_c(model_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_view_list >
{
   static constexpr int value = 
#if defined(ELM_VIEW_LIST_PROTECTED) && defined(ELM_VIEW_LIST_BETA)
      5
#elif defined(ELM_VIEW_LIST_PROTECTED)
      5
#elif defined(ELM_VIEW_LIST_BETA)
      5
#else
      5
#endif
      + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_view_list>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_list_evas_object_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_list_evas_object_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_list_property_connect_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_list_property_connect);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_list_model_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_list_model_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_list_model_unset_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_list_model_unset);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_view_list_model_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_view_list_model_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm_view_list >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_view_list>)
{
   return (ELM_VIEW_LIST_CLASS);
}

} } }

/// @endcond

